package com.brilliance.isc.swift.objmtconvert.model.mt9xx;

import com.brilliance.isc.swift.objmtconvert.annotation.FieldDescription;
import com.brilliance.isc.swift.objmtconvert.annotation.Status;
import com.brilliance.isc.swift.objmtconvert.annotation.TagName;
import com.brilliance.isc.swift.objmtconvert.annotation.TagRegex;
import com.brilliance.isc.swift.objmtconvert.model.AbsMTCreator;
import com.brilliance.isc.swift.objmtconvert.model.AbsTagCreate;
import com.brilliance.isc.swift.objmtconvert.model.mt9xx.tag.tag992.*;
import com.brilliance.isc.swift.objmtconvert.result.MtResult;

import java.util.ArrayList;
import java.util.List;

public class MT992Creator extends AbsMTCreator {
    @Status("M")
    @TagName("20")
    @FieldDescription("Transaction Reference Number")
    @TagRegex("16x")
    //20
    private String transactionReferenceNumber;
    @Status("M")
    @TagName("21")
    @FieldDescription("Related Reference")
    @TagRegex("16x")
    //21
    private String relatedReference;
    @Status("M")
    @TagName("11S")
    @FieldDescription("MT and Date of the Original Message")
    @TagRegex("3!n<crlf>6!n<crlf>[4!n6!n]")
    //11S
    private String mtandDateoftheOriginalMessage;
    @Status("O")
    @TagName("79")
    @FieldDescription("Narrative Description of the Original Message")
    @TagRegex("35*50x")
    //79
    private String narrativeDescriptionoftheOriginalMessage;


    public String getTransactionReferenceNumber() {
        return transactionReferenceNumber;
    }

    public void setTransactionReferenceNumber(String transactionReferenceNumber) {
        this.transactionReferenceNumber = transactionReferenceNumber;
    }

    public String getRelatedReference() {
        return relatedReference;
    }

    public void setRelatedReference(String relatedReference) {
        this.relatedReference = relatedReference;
    }

    public String getMtandDateoftheOriginalMessage() {
        return mtandDateoftheOriginalMessage;
    }

    public void setMtandDateoftheOriginalMessage(String mtandDateoftheOriginalMessage) {
        this.mtandDateoftheOriginalMessage = mtandDateoftheOriginalMessage;
    }

    public String getNarrativeDescriptionoftheOriginalMessage() {
        return narrativeDescriptionoftheOriginalMessage;
    }

    public void setNarrativeDescriptionoftheOriginalMessage(String narrativeDescriptionoftheOriginalMessage) {
        this.narrativeDescriptionoftheOriginalMessage = narrativeDescriptionoftheOriginalMessage;
    }


    public MT992Creator(String msgType)  {
    super(msgType);
}

    public void pack() {
       // MtResult mtResult = new MtResult();
        List<AbsTagCreate> tagCreateList=new ArrayList<>();
        try {
            tagCreateList.add(new Tag20Creator(this));
            tagCreateList.add(new Tag21Creator(this));
            tagCreateList.add(new Tag11SCreator(this));
            tagCreateList.add(new Tag79Creator(this));
//            tagCreateList.add(new TagCreator(this));


            dealTags(tagCreateList);

            mtResult.setMessage(abstractMT.message());
        } catch (Exception e) {
            e.printStackTrace();
            mtResult.setSuccess(false);
            mtResult.addDescription(e.getLocalizedMessage());
        }

        //return mtResult;

    }

    public MtResult unpack() {
        return null;
    }
}
